package	jp.co.sds_corp.util.pooh.dialog;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import jp.co.sds_corp.util.pooh.simple.SimpleDialog;
import jp.co.sds_corp.util.pooh.top.Toplevel;

public class DialogManager {

	Map dialogMap = new HashMap();
	Toplevel toplevel = null;

	public DialogManager(Toplevel _toplevel) {toplevel = _toplevel;}
	public void remove(String fn) { dialogMap.remove(fn); }
	public void removeAll() { dialogMap.clear(); }

	public void add(String fn, Object dialog) { dialogMap.put(fn, dialog); }
	public Object get(String fn) { return dialogMap.get(fn); } 

	public Object getDialogResource(String fn) throws Exception {
		DialogParser parser = new DialogParser(toplevel);
		return parser.loadResource(fn);	
	}

	public Object createDialog(DialogResource request) throws Exception {
		request.setDialog(new SimpleDialog(toplevel, request));
		add(request.getDialog_id(), request);
		return request;
	}

	public Object createDialog(String fn) throws Exception {
		DialogParser parser = new DialogParser(toplevel);
		return createDialog(parser.loadResource(fn));	
	}

	public void loadResourceAll(String path, String resType) {
		try {
			DialogParser parser = new DialogParser(toplevel);
			DialogResource [] drs = parser.loadResourceAll(path, resType);
			for (int i=0; i<drs.length; i++)
				add(drs[i].getDialog_id(), drs[i]);
		} catch (Exception e) {}
		return;
	}

	public void closed() {
		Iterator iterator = dialogMap.values().iterator();
		while (iterator.hasNext()) {
			DialogResource info = (DialogResource)iterator.next();
			SimpleDialog dialog = info.getDialog();
			dialog.closed();
		}
		dialogMap.clear();
	}

	public boolean isAlive(String fn) { return (get(fn) != null) ? true : false; }
	public Iterator iterator() { return dialogMap.values().iterator(); }
}
