package	jp.co.sds_corp.util.pooh.simple;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.border.EmptyBorder;

import jp.co.sds_corp.util.pooh.dialog.SimpleDialogListener;
import jp.co.sds_corp.util.pooh.pane.CustButton;

public class SimpleButtonPane extends JPanel implements CustButton, ActionListener {

	private SimpleButton [] buttons;
	private SimpleDialogListener listener = null;
	public  SimpleDialog parent;

	public SimpleButtonPane(){}
	public void setButton_id(int index, int _indicate) {
		buttons[index].setButton_id(_indicate);
	}

	public int getButton_id(int index) {
		return buttons[index].getButton_id();
	}

	public void createButton(JDialog _parent, int c) {
		parent = (SimpleDialog)_parent;
		setLayout(new BorderLayout());
		add(makeButton(c), "Center");
		add(new JSeparator(), "North");
		setBorder(new EmptyBorder(new Insets(0, 10, 0, 10)));
		_parent.getRootPane().setDefaultButton(buttons[0]);
	}

	private JPanel makeButton(int c) {
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.setBorder(new EmptyBorder(new Insets(5, 0, 5, 0)));
		buttons = new SimpleButton[c];
		Box box = new Box(BoxLayout.X_AXIS);
		ButtonGroup group = new ButtonGroup();

		for (int i=0; i<c-1; i++) {
			buttons[i] = new SimpleButton("button_" + i);
			group.add(buttons[i]);
			box.add(buttons[i]);
			box.add(Box.createHorizontalStrut(3));
			buttons[i].addActionListener(this);
			buttons[i].setButton_id(i);
		}

		buttons[c-1] = new SimpleButton("Cancel");
		buttons[c-1].setMnemonic(KeyEvent.VK_C);
		buttons[c-1].addActionListener(this);
		buttons[c-1].setButton_id(c-1);

		group.add(buttons[c-1]);
		box.add(Box.createHorizontalStrut(7));
		box.add(buttons[c-1]);
		panel.add(box, "East");

		return panel;
	}

	public int getButtons() { return buttons.length; }
	public void setListener(SimpleDialogListener l) {
		listener = l;
	}

	public void closed() {
		for (int i=0; i<buttons.length; i++)
			buttons[i].removeActionListener(this);
		removeAll();
	}

	public void setEnabled(int _idx, boolean _enable) {
		buttons[_idx].setEnabled(_enable);
	}

	public void setDefaultButton(int idx) {
		parent.getRootPane().setDefaultButton(buttons[idx]);
	}

	public void setButtonFace(int idx, String title, int mnemonic) {
		buttons[idx].setText(title);
		buttons[idx].setMnemonic(mnemonic);
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == buttons[buttons.length-1]) {
			parent.hide();
			parent.setAction(buttons[buttons.length-1].getButton_id());
			closed();
		} else {
			for (int i=0; i<buttons.length-1; i++) {
				if (e.getSource() == buttons[i]) {
					if (listener != null) {
						listener.doAction(i);
					}
					break;
				}
			} 
		}
	}
}
