package	jp.co.sds_corp.util.pooh.simple;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.Window;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Vector;

import javax.swing.DefaultDesktopManager;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import jp.co.sds_corp.util.pooh.custom.WaitCursor;
import jp.co.sds_corp.util.pooh.dialog.DialogManager;
import jp.co.sds_corp.util.pooh.dialog.DialogResource;
import jp.co.sds_corp.util.pooh.frame.FrameManager;
import jp.co.sds_corp.util.pooh.frame.FrameResource;
import jp.co.sds_corp.util.pooh.menu.MenuManager;
import jp.co.sds_corp.util.pooh.menu.MenuResource;
import jp.co.sds_corp.util.pooh.menu.RootMenuResource;
import jp.co.sds_corp.util.pooh.menu.SubMenuResource;
import jp.co.sds_corp.util.pooh.toolbar.ToolbarParser;
import jp.co.sds_corp.util.pooh.toolbar.ToolbarResource;
import jp.co.sds_corp.util.pooh.top.TopWindow;
import jp.co.sds_corp.util.pooh.top.Toplevel;
import jp.co.sds_corp.util.window.StatusBar;

public abstract class SimpleMdiFrame extends JFrame implements TopWindow {

	protected JDesktopPane desktop;
	protected DefaultDesktopManager desktopMan;
	protected StatusBar statusBar;
	protected MenuManager mManager;
	protected FrameManager fManager;
	protected DialogManager dManager;
	protected Toplevel toplevel;
	protected String currentMenu;

	private static final int FRAME_X = 0;
	private static final int FRAME_Y = 0;


	private static final int OFFSET_INSET = 25;

	private int CUR_FRAME_X;
	private int CUR_FRAME_Y;
	private int FRAME_W;
	private int FRAME_H;
	private int FRAMES = 0;

	public SimpleMdiFrame() {
		int inset = 50;
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		setBounds(inset, inset, screenSize.width  - inset*2, screenSize.height - inset*2);
		setDefaultCloseOperation(0);
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
                if (systemButtonClosing()) {
					exit();
				}
            }
        });
		desktop = new JDesktopPane();
		desktopMan = new DefaultDesktopManager();

		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(desktop, "Center");
		CUR_FRAME_X = FRAME_X;	
		CUR_FRAME_Y = FRAME_Y;	
		FRAME_W = getWidth()  / 2 ;
		FRAME_H = getHeight() / 2 ;
	}

	public int getFrame_x(int w) {
		int W = (w == -1) ? FRAME_W : w;
		if ((CUR_FRAME_X+W) >= getWidth()) {
			CUR_FRAME_X = 0;
			FRAMES = 0;
		} else {
			CUR_FRAME_X = OFFSET_INSET * FRAMES;
		}
		return CUR_FRAME_X;
	}

	public int getFrame_y(int h) {
		int H = (h == -1) ? FRAME_H : h;
		if ((CUR_FRAME_Y+H) >= getHeight()) {
			CUR_FRAME_Y = 0;
			FRAMES = 0;
		} else {
			CUR_FRAME_Y = OFFSET_INSET * FRAMES;
			FRAMES++;
		}
		return CUR_FRAME_Y;
	}

	public int getFrame_w() { return FRAME_W; }
	public int getFrame_h() { return FRAME_H; }

	public void setToplevel(Toplevel _toplevel) { 
		try {
			toplevel = _toplevel;
			mManager = new MenuManager(_toplevel);
			dManager = new DialogManager(_toplevel);
			fManager = new FrameManager(_toplevel);
			toplevel.setAttribute("WaitCursor", new WaitCursor((Window)this));
		} catch (Exception e) {}
	}

	public void defaultUIResource() {}

	public void initialFrame(String name) throws Exception {
		setWindowTitle(name);
		if (mManager != null)
            mManager.closed();

		if (fManager != null)
            fManager.closed();
	}

	public void concatWindowTitle(String title) {setTitle(getTitle() + title);}
	public void setWindowMenuBar(JMenuBar menu) { setJMenuBar(menu); }
	public void setWindowTitle(String name) { setTitle(name); }
	public void showframe(boolean b) { setVisible(b); }
	public StatusBar getStatusBar() { return statusBar; }

	public FrameResource getFrameResource(String frame) throws Exception {
		return (FrameResource)fManager.getFrameResource(frame);
	}

	public FrameResource [] getFrameResource(String frame, int c) throws Exception {
		return null;
	}

	/**
	* ��ư������ƤΥե졼��꥽������������ޤ���
	* @return FrameResource[]  
	*/
	public FrameResource [] getFrameResources() throws Exception {
		return (FrameResource [])fManager.getAllFrames();
	}

	/**
	* key�˻��ꤷ������ư������ƤΥե졼��꥽������������ޤ���
	* @param key ��������
	* @return FrameResource[]
	*/
	public FrameResource [] getFramesByKey(String key) throws Exception {
		return (FrameResource [])fManager.getFramesByKey(key);
	}

	/**
	* key�˻��ꤷ������ư������ƤΥե졼��꥽������������ޤ���
	* @param key ��������
	* @param title �ե졼��Υ����ȥ� 
	* @return FrameResource[]
	*/
	public FrameResource [] getFramesByKey(String key, String title) throws Exception {
		return (FrameResource [])fManager.getFramesByKey(key, title);
	}

	/**
	* key�ǻ��ꤵ�줿����ư��Υե졼�����ƥ��?�����ޤ�
	* @param key ��������
	*/
	public void closedFrameByKey(String key) throws Exception {
		FrameResource [] ress =  (FrameResource [])fManager.getFramesByKey(key);
		for (int i=0; i<ress.length; i++) {
			ress[i].getFrame().closed();
			ress[i].getFrame().setClosed(true);
		}
	}

	/**
	* ��ư������ƤΥե졼��򥯥?�����ޤ���
	*/
	public void closedAllFrames() throws Exception {
		FrameResource [] ress =  (FrameResource [])fManager.getAllFrames();
		for (int i=0;i<ress.length; i++) {
			ress[i].getFrame().closed();
			ress[i].getFrame().setClosed(true);
		}
	}


	public FrameResource getActiveFrameResource() throws Exception {
		SimpleInternalFrame sif  = (SimpleInternalFrame)desktop.getSelectedFrame();
		if (sif == null)
			return null;
		return (FrameResource)fManager.get(fManager.makeKey(sif));
	}

	public DialogResource getDialogResource(String dialog) throws Exception {
		return (DialogResource)dManager.getDialogResource(dialog);
	}

	public void createMenu(String menu) throws Exception {
		MenuResource f = (MenuResource)mManager.createMenu(menu);
	}

	public void createToolBar(String menu) throws Exception {
		ToolbarParser parser = new ToolbarParser(toplevel);
		ToolbarResource f = (ToolbarResource)parser.loadResource(menu);
		f.createToolbar(toplevel);
		JPanel p = new JPanel(new BorderLayout());
		p.add(f.getToolbar(), "Center");
		getContentPane().add(p, "North");
		toplevel.setAttribute(toplevel.TOOL_BAR, p);
	}

	public void createDialog(String dialog) throws Exception {
		DialogResource f = (DialogResource)dManager.createDialog(dialog); 
	}

	public void createFrame(String frame) throws Exception {
		SubMenuResource sb = (SubMenuResource)toplevel.getAttribute(frame);
		FrameResource f = null;
		if (sb!=null) {
			f = (FrameResource)fManager.createFrame(frame, sb.getOpen());
		} else { 
			f = (FrameResource)fManager.getFrameResource(frame);
			f = (FrameResource)fManager.createFrame(f);
		}

		if (f != null) {
			f.getFrame().setVisible(true);
			desktop.add(f.getFrame());
			f.getFrame().setSelected(true);
		}
	}

	public void createStatusBar(int barcount) {
		try {
			statusBar = new StatusBar(barcount);
			getContentPane().add(statusBar, "South");
			toplevel.setAttribute(toplevel.STATUS_BAR, statusBar);
		} catch (Exception e) { e.printStackTrace(); }
	}

	public void activeMenu(String menu) throws Exception {
		try {
			MenuResource f = (MenuResource)mManager.get(menu);
			setWindowMenuBar(f.getMenuBar());
			f.getMenuBar().setVisible(false);
			f.getMenuBar().setVisible(true);
			currentMenu = menu;
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	public RootMenuResource getRootMenuResource(int key) {
		return ((MenuResource)mManager.get(currentMenu)).getRootMenuResource(key);
	}

	public void setRootMenuEnabled(int index, boolean b) {}
	public void setSubMenuEnabled(SubMenuResource sub, boolean b) {
		if (sub.getType() == SubMenuResource.MENU_MENU) {
			(sub.getSimpleMenu()).setEnabled(b);
		} else {
			((JMenuItem)sub.getThis()).setEnabled(b);
		}
	}

	/**
	*
	*/
	public SimpleInternalFrame createFrame(FrameResource request) throws Exception {
		FrameResource resource = new FrameResource();
		resource.copy(request);
		FrameResource f = (FrameResource)fManager.createFrame(resource); 
		return (SimpleInternalFrame)f.getFrame();
	}

	/**
	*
	*/
	public void createFrames(FrameResource [] ress) throws Exception {
		for (int i=0; i<ress.length; i++) {
			FrameResource f = (FrameResource)fManager.createFrame(ress[i]); 
		}
	}

	public SimpleDialog createDialog(DialogResource request) throws Exception {
		DialogResource d = (DialogResource)dManager.createDialog(request); 
		return d.getDialog();
	}

	public void addFrame(SimpleInternalFrame frame) throws Exception {
		frame.setVisible(true);
		desktop.add(frame);
		frame.setSelected(true);
		frame.toFront();
	}

	public void createFrame() {}
	public abstract void mainLoop();
	public abstract boolean systemButtonClosing();

	public void exit() {
		if (mManager != null)
            mManager.closed();
		if (fManager != null)
            fManager.closed();
		hide();
		dispose();
	}

	public void doWindowLists(SubMenuResource res) {
		try {
			DialogResource request = new DialogResource();
			request.setDialog_id("WINDOW_LISTS");
			request.setDialog_type("dialog");
			request.setDialog_name("������ɥ�");
			request.setDialog_x("200");
			request.setDialog_y("200");
			request.setDialog_w("460");
			request.setDialog_h("300");
			request.setDialog_style("true");
			request.setDialog_resize("false");
			request.setDialog_btn("normal");
			request.setDialog_btns("2");
			request.setDialog_btnp("jp.co.sds_corp.util.pooh.simple.SimpleButtonPane");
			request.setDialog_p("jp.co.sds_corp.util.pooh.custom.WindowLists");
			Vector vect = new Vector();
			JInternalFrame[] frames = desktop.getAllFrames();
			for (int i=0;i<frames.length; i++) {
				vect.add(frames[i].getTitle());
			}
			request.setUserAttribute(vect);
			SimpleDialog dialog = createDialog(request);
			dialog.show();
			if (dialog.getAction() == SimpleButton.OK) {
				if (frames.length > 0) {
					Integer sIndex = (Integer)request.getUserAttribute();
					frames[sIndex.intValue()].setSelected(true);
				}
			}
		} catch (Exception e) { e.printStackTrace(); }
	}

	public void doSwingEvent(int nEventType, Object [] params) {}
	public JDesktopPane getDesktopPane() { return desktop; }
	public int getWindowType() { return TopWindow.TYPE_MDI; }
	public MenuManager getMenuManager() { return mManager; }
	public FrameManager getFrameManager() { return fManager; }
}
