package	jp.co.sds_corp.util.pooh.tools;

import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;

import jp.co.sds_corp.util.pooh.top.DesktopPartsInfo;
import jp.co.sds_corp.util.pooh.top.DesktopResource;
import jp.co.sds_corp.util.xml.CmnXMLWriter;

import org.w3c.dom.Element;

public class OutputDesktopResource extends CmnXMLWriter {

	public OutputDesktopResource() throws Exception { createDocument("desktop"); }

	public void writeResource(String file, DesktopResource fr) throws Exception {
		getRoot().appendChild(setProducts(fr));
		getRoot().appendChild(setDesktop_attribute(fr));
		getRoot().appendChild(setDesktop_parts(fr));
		printFile(new File(file));
	}

	private Element setDesktop_parts(DesktopResource fr) {
		Element root = createElement("desktop-parts");
		LinkedList list = fr.getDesktopPartsLists();
		Iterator iterator = list.iterator();
		while (iterator.hasNext()) {
			Element ele = createElement("parts");
			DesktopPartsInfo info = (DesktopPartsInfo)iterator.next();
			setAttribute(ele, "type", info.getType());
			if (info.getInt_type() == DesktopPartsInfo.MENU_BAR)
				setAttribute(ele, "key", info.getKey());
			else if (info.getInt_type() == DesktopPartsInfo.STATUS_BAR)
				setAttribute(ele, "barcount", String.valueOf(info.getBarcount()));
			root.appendChild(ele);
		}
		return root;
	}

	private Element setDesktop_attribute(DesktopResource fr) {
		Element root = createElement("desktop-attri");
		setAttribute(root, "name", fr.getStart_object_name());
		setAttribute(root, "object", fr.getStart_object());
		return root;
	}

	private Element setProducts(DesktopResource fr) {
		Element root = createElement("products");
		setAttribute(root, "version", fr.getProducts().getVersion());
		setAttribute(root, "url", fr.getProducts().getUrl());
		setAttribute(root, "copyright", fr.getProducts().getCopyright());
		setAttribute(root, "product", fr.getProducts().getProduct());
		return root;
	}

	public void setAllResource(String file, DesktopResource fm) throws Exception {
		writeResource(file, fm);
	}
}
