package	jp.co.sds_corp.util.pooh.tools;

import java.io.File;
import java.util.Iterator;

import jp.co.sds_corp.util.pooh.toolbar.ButtonInfo;
import jp.co.sds_corp.util.pooh.toolbar.ToolbarManager;
import jp.co.sds_corp.util.pooh.toolbar.ToolbarResource;
import jp.co.sds_corp.util.xml.CmnXMLWriter;

import org.w3c.dom.Element;

public class OutputToolbarResource extends CmnXMLWriter {

	private Element root = null;
	public OutputToolbarResource() throws Exception {
		createDocument("gui");
	}

	public void setToolbars() {
		root = createElement("toolbars");
	}

	public void setToolbar(ToolbarResource tbr) throws Exception {
		Element elm = createElement("toolbar");
		elm.setAttribute("name", tbr.getToolbar_name());
		for (int i=0; i<tbr.rootSize(); i++) {
			elementSet(elm, tbr.getButtonInfo(i));
		}
		root.appendChild(elm);
	}

	public void writeResource(String file) throws Exception {
		getRoot().appendChild(root);
		printFile(new File(file));
	}

	public void setAllResource(String file, ToolbarManager mr) throws Exception {
		setToolbars();
		if (mr != null) {
			Iterator iterator = mr.iterator();
			if (iterator != null) {
				while (iterator.hasNext()) {
					ToolbarResource tbr = (ToolbarResource)iterator.next();
					setToolbar(tbr);
				}
			}
		}
		writeResource(file);
	}

	private void elementSet(Element e, ButtonInfo info) throws Exception {
		Element ele = createElement("item");
		ele.setAttribute("name",     info.getName());
		ele.setAttribute("enable",   String.valueOf(info.getEnabled()));
		ele.setAttribute("type",     info.getSzBtnType());

		ele.setAttribute("roll-icon"	, info.getSzUpIcon());
		ele.setAttribute("up-icon"		, info.getSzPressedIcon());
		ele.setAttribute("press-icon"	, info.getSzDisabledIcon());
		ele.setAttribute("disable-icon"	, info.getSzRollIcon());

		if (info.getSzListener().length() > 0)
			ele.setAttribute("listener", info.getSzListener());

		if (info.getMenuLink().length() > 0)
			ele.setAttribute("menu-link",     info.getMenuLink());

		ele.setAttribute("index",     String.valueOf(info.getBtn_index()));
		e.appendChild(ele);
	}
}
