package	jp.co.sds_corp.util.prop;

import java.util.LinkedList;

import org.w3c.dom.Node;

public class ELM {
	public ELM parent;
	public Node me;
	public LinkedList children = null;
	public int index = 1;
	public boolean grouping;
	public String name;

	public ELM(ELM _parent, String _me, int _index) throws Exception {
		parent   = _parent;
		name     = _me;
		index    = _index;
		grouping = false;
	}

	public ELM(ELM _parent, Node _me) throws Exception {
		parent = _parent;
		me = _me;
		grouping = false;
		name = me.getNodeName();
	}

	public void setChild(ELM elm) throws Exception {
		if (children == null ) { 
			children = new LinkedList();
		}
		children.add(elm);
	}

	public String getPropName() {
		return (index == -1) ? name : name + "." + index;
	} 

	public String getName() {
		return name;
	} 

	public LinkedList getChildren() { return children; }
	public ELM getParentELM() { 
		return (parent==null) ? this : parent;
	}

	public String toString() { 
		return me.getNodeName();
	}
}
